#include <SoftwareSerial.h>
#include <NewPing.h>
#define TRIGGER_PIN 12
#define ECHO_PIN 13
#define MAX_DISTANCE 200

NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE);

SoftwareSerial mySerial(10,11);// TX, RX

char ReceivedData;

int LM1=2;
int LM2=3;
int RM1=4;
int RM2=5;

int LED=8;

void Stop()
{
  digitalWrite(LM1,LOW);
  digitalWrite(LM2,LOW);
  digitalWrite(RM1,LOW);
  digitalWrite(RM2,LOW);
  
  }
void Forward()
{
  digitalWrite(LM1,LOW);
  digitalWrite(LM2,HIGH);
  digitalWrite(RM1,LOW);
  digitalWrite(RM2,HIGH);
    
}
void Backward()
{
  
  digitalWrite(LM1,HIGH);
  digitalWrite(LM2,LOW);
  digitalWrite(RM1,HIGH);
  digitalWrite(RM2,LOW);
  
}
void SpotRight()
{
  
  digitalWrite(LM1,HIGH);
  digitalWrite(LM2,LOW);
  digitalWrite(RM1,LOW);
  digitalWrite(RM2,HIGH);
  
}
void SpotLeft()
{
  
  digitalWrite(LM1,LOW);
  digitalWrite(LM2,HIGH);
  digitalWrite(RM1,HIGH);
  digitalWrite(RM2,LOW);
  
}
void setup()
{
  pinMode(LM1,OUTPUT);
  pinMode(LM2,OUTPUT);
  pinMode(RM1,OUTPUT);
  pinMode(RM2,OUTPUT);
  pinMode(LED,OUTPUT);
  Serial.begin(9600);
  mySerial.begin(9600);
}
void loop()
{

int distance=sonar.ping_cm();

if(mySerial.available()>0)
{
  ReceivedData=mySerial.read();
}
//Check Distance and Proceed
if(ReceivedData=='B')
{ 
  Forward();
  //SetSpeed(200);
  Serial.println("FORWARD");
}
else if(ReceivedData=='F')
{
  Backward();
  //SetSpeed(200);
  Serial.println("Backward");
}
else if(ReceivedData=='R')
{
  SpotLeft();
  //SetSpeed(180);
  Serial.println("Left");
}
else if(ReceivedData=='L')
{
  SpotRight();
  //SetSpeed(180);
  Serial.println("Right");
}
else
{
  Stop();
  Serial.println("Stop");
}
//LED
if (distance>0 && distance<=10)
{
  digitalWrite(LED,HIGH);
  Serial.print("Ping");
  Serial.print(distance);
  Serial.println("cm");
  delay(500);
}
else
{
  digitalWrite(LED,LOW);
  Serial.print("No obstacle detected");
}
}
